.fo 'BWE'- % -'Description'
.po +0.5i
.ll 6.5i
.ps 11p
.nr pp 11
.nr sp 11
.]-
.ds <. .
.ds <, ,
.sp 1i
.(l C
.sz +2
.ft B
BWE:  The Brown Workstation Environment
.ft
.sz
.sp 1
.b "Steven P. Reiss"
.sp 1
Department of Computer Science
Brown University
Providence, RI 02912
spr@cs.brown.edu   (401) 863-7641
April, 1989
.)l
.sp 1
.(q
The Brown Workstation Environment is a set of high-level user interface tools
designed to simplify the programmers task in putting together window-based
interfaces for applications.
.)q
.sp 1
.pp
The Brown Workstation Environment is a user interface toolkit that has evolved
at Brown over the past seven years.  It includes a variety of tools, ranging
from a low-level graphics package to a powerful and extensible text editor.
The tools have been used in a variety of research and student projects at Brown
on a variety of different workstations.  The toolkit was designed as a set of
high level packages to simplify user interface programming.  As such, it
differs substantially from most proposed widget-based toolkits that emphasize
flexibility.  The toolkit is compatible with the lightweight process package
THREADS developed at Brown by Tom Doeppner.
.pp
BWE includes a variety of packages.  The basic graphics package, ASH, provides
a simplified interface to X11 graphics.  The basic input
package, BIO, provides event mapping and queueing, including the correct
processing of input for multi-threaded programs.  Input in BWE is usually done
via call-backs using RIP.  RIP allows the program to associate any region of
any window with a set of events and a routine.  When any of the designated
actions occurs within that region, the given routine is called by the input
manager.  CMPX offers a generalized select facility.  AUXD offers a
hierarchical resource management facility for the application.  WORM offers a
dynamic object-oriented capability.
.pp
A second level of packages provides basic control over window layout and menus.
LEAF allows the programmer to describe via a simple table a constraint-based
window layout.  STEM
provides a host of higher-level input capabilities including pull-down and
pop-up menus, scrollable static menus, state menus, scroll bars, and dialog
boxes.  All these are provided with simplified interfaces.  The pop-up,
pull-down and static menus are defined via tables.  The state menus and dialog
boxes are defined via printf/scanf-style strings.  WIND provides an in-process window
manager that is designed to cooperate with X11 window managers.
.pp
BWE also includes a powerful text editor, EDT.  This editor can be used for
everything from a simple text input window inside a dialog box, to a standard
file editor, to an interactive transcriptor.  It supports user-definable
commands and key bindings, language-specific indenting and commands,
shared named buffers, multiple views of a single file with consistent updating,
extensibility through dynamically loaded C code, as well as a rich set of
built-in commands.
.pp
Finally BWE contains the basic data and program structure display facilities
that are used by GARDEN and FIELD.  This includes three packages.  The basic
package, GELO, handles the automatic display of structured diagrams.  The APPLE
editor allows the user to
quickly and interactively describe how a type should be displayed in GELO and
maps data of this type into the appropriate GELO structures.  The PEAR editor
provides a graphical editor around a GELO display.
.pp
BWE is currently implemented on top of X11.  It runs on a variety of machines
including Sun3 and Sun4 workstations, DEC vaxes, the Decstation 3100, and an
Encore multimax.  It should be easy to port to any UNIX-based workstation that
has a working X11 implementation.
